include:
  - project: 'mobica-workshops/templates/ci/gitlab-ci'
    file:
      - 'default.pipeline.v5.yml'
      - '.go-ci-template.yml'
      - '.e2e_test_ci_template.yml'
    ref: e2e_coverage_exit_code

###############################################
# pre-build-tests stage
###############################################
# Run code style and static analysis on the code
static_analyse:
  extends:
    .go_static_analysis_job_definition
  stage: pre-build-tests
  dependencies:
    - configure

# Run UT tests with coverage enabled
unit_tests:
  dependencies:
    - configure
  stage: pre-build-tests
  extends:
    .go_run_unit_tests_with_coverage

###############################################
# Build stage
###############################################
# Build application
build_package:
  extends:
    .go_build_job_definition
  stage: build
  dependencies:
    - configure
    - static_analyse
    - unit_tests

###############################################
# post-build-tests stage
###############################################
# Run E2E tests with coverage enabled (Currently always as it is a part of post stage)
e2e_tests:
  dependencies:
    - configure
    - unit_tests
  stage: post-build-tests
  extends:
    .go_run_e2e_tests_with_coverage

# Benchmark test
benchmark:
  stage: post-build-tests
  extends: .e2e_test_job_definition
  variables:
    BENCHMARK: "true"
  artifacts:
    expire_in: 1 week
    paths:
      - "benchmark*.svg"
  needs:
    - test_image
    - configure
    - unit_tests
  only:
    - tag
    - merge_requests
    - master
  allow_failure: true
  when: manual

###############################################
# Post stage
###############################################
# Generate cumulative html report from unit tests and e2e tests
cumulative_coverage:
  stage: .post
  extends:
    .cumulative_coverage_report
  variables:
    PACKAGE_LIST: package1=coverage_ut.xml package2=coverage_e2e.xml
  dependencies:
    - e2e_tests
    - unit_tests
  allow_failure: true

